#pragma once

#include "RFVoxelOctree.h"
#include <vector>

namespace RFAxl
{

	class RFVoxelOctreeBuilder
	{
	public:
		RFVoxelOctreeBuilder();
		~RFVoxelOctreeBuilder();
		RFVoxelOctree *CreateOctree(const std::vector<RFMath::RFVector3f> &kMeshVertices, const RFMath::RFAABB3f kMeshAabb, const float fVoxelSize = 1.0f, const float fMinCoverage = 0.9f, const float fBorderSize = 1.0f);

	private:

		void Subdivide(RFVoxelOctreeNode *pkParentNode, const std::vector<RFMath::RFVector3f> &kMeshVertices, const std::vector<uint> &kNodeTriangleIndices);
		void UpdateLeafNodeDistanceValue(RFVoxelOctreeNode *pkLeafNode, const std::vector<RFMath::RFVector3f> &kMeshVertices, const std::vector<uint> &kNodeTriangleIndices);
		void UpdateInternalEmptyLeafsSign(const RFVoxelOctreeNode *pkOctreeRoot, RFVoxelOctreeNode *pkNode, const float fMinCoverage);
		void UpdateOctreeStats(RFVoxelOctree *pkOctree);
		void UpdateOctreeStats(RFVoxelOctree *pkOctree, RFVoxelOctreeNode *pkNode);

		std::vector<RFMath::RFVector3f> m_kSampleDirections; // Use
		RFVoxelOctree *m_pkVoxelOctree;
	};

}